var Rec43000_ParametroContasReceber_Controller = function(ScreenService, General, templateManager, Rec43000_ParametroContasReceber_Service){
    
    var self = this;
    
    self.afterLoadSource = function(widget){
        var data = widget.dataSource.data[0];
        var dataEmpty = {
            'CDAJACREREC':'',
            'CDAJACRERENEGO':'',
            'CDAJDESCREC':'',
            'CDAJDESCRENEGO':'',
            'CDAJMORAREC':'',
            'CDAJMULTAREC':'',
            'CDAJTXCARTCNAB':'',
            'CDGERALREC':'',
            'CDGROPERCNTR':'',
            'CDMOTIPROR':'',
            'CDTPBXRENEGO':'',
            'DSAJACREREC':'',
            'DSAJACRERENEGO':'',
            'DSAJDESCREC':'',
            'DSAJDESCRENEGO':'',
            'DSAJMORAREC':'',
            'DSAJMULTAREC':'',
            'DSAJTXCARTCNAB':'',
            'DSMOTIPROR':'',
            'DSTPBXRENEGO':'',
            'IDBLOQALTBOLREC':'N',
            'IDBLOQINCNTR':'',
            'IDCOMPCHQBAIXA':'S',
            'IDEXTELACALAJUBX':'B',
            'IDTPCNTRLIB':'',
            'IDUTBCOPREFCLIE':'N',
            'IDUTCTRLCANREMR':'',
            'IDUTLNFDEVOLREC':'N',
            'IDUTLPRORVCREC':'',
            'NRORG':'',
            'QTDIAANTBAIR':'',
            'QTDIAANTBOLR':'',
            'QTDIAANTLANR':'',
            'QTDIAAPOBAIR':'',
            'QTDIAAPOBOLR':'',
            'QTDIAAPOLANR':'',
            'IDEXCLAJBBXR':'N',
            'IDUTENVBOLAUTO':'N',
            'QTDIAANTENVBOL':'',
            'IDUTENVCARTAUTO':'N',
            'QTDIAPOSENVCAR':'',
            'CDTPBAIRENVBOL':'',
            'IDUTVISUBOLOPEL':'N',
            'CDOPEPERVISUBOL':''
        };
        var dados = null;
        if (data) {
            dados = data;
            dados.__is_new = false;
            
            data.CDTPBAIRENVBOL_multi = data.CDTPBAIRENVBOL?data.CDTPBAIRENVBOL.split('_'):'';
            widget.getField('CDTPBAIRENVBOL_multi').reload();
            
            data.CDOPEPERVISUBOL_multi = data.CDOPEPERVISUBOL?data.CDOPEPERVISUBOL.split('_'):'';
            widget.getField('CDOPEPERVISUBOL_multi').reload();
            widget.redraw();
        }else{
            dados = dataEmpty;
            dados.__is_new = true;
        }
        
        widget.currentRow = dados;
        
        var intervaloDatasForm = templateManager.container.getWidget('intervaloDatasForm');
        intervaloDatasForm.currentRow.QTDIAANTLANR = dados.QTDIAANTLANR;
        intervaloDatasForm.currentRow.QTDIAAPOLANR = dados.QTDIAAPOLANR;
        intervaloDatasForm.currentRow.QTDIAANTBAIR = dados.QTDIAANTBAIR;
        intervaloDatasForm.currentRow.QTDIAAPOBAIR = dados.QTDIAAPOBAIR;
        intervaloDatasForm.currentRow.QTDIAANTBOLR = dados.QTDIAANTBOLR;
        intervaloDatasForm.currentRow.QTDIAAPOBOLR = dados.QTDIAAPOBOLR;
        
        templateManager.updateTemplate();
    };

    self.saveTabeds = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        var rowsToSave   = [];
        
        widgetsTabed[0].currentRow.CDTPBAIRENVBOL  = widgetsTabed[0].currentRow.CDTPBAIRENVBOL_multi?widgetsTabed[0].currentRow.CDTPBAIRENVBOL_multi.join('_'):'';
        widgetsTabed[0].currentRow.CDOPEPERVISUBOL = widgetsTabed[0].currentRow.CDOPEPERVISUBOL_multi?widgetsTabed[0].currentRow.CDOPEPERVISUBOL_multi.join('_'):'';

        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            rowsToSave.push(widget.currentRow);
        }

        Rec43000_ParametroContasReceber_Service.saveWidgets(rowsToSave, rowsToSave[0].__is_new).then(function () {
            widgetsTabed[0].view();
            widgetsTabed[0].template = widgetsTabed[0].templateToView;
            widgetsTabed[1].view();
            widgetsTabed[1].template = widgetsTabed[1].templateToView;
            widgetsTabed[0].reload();
            widgetsTabed[1].reload();
            widgetsTabed[0].currentRow.__is_new = false;
            self.afterLoadSource(widgetsTabed[0]);
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    self.editMode = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            General.edit(widget);
            widget.template = widget.templateToForm;
        }
    };

    self.backToView = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            widget.view();
            widget.currentRow = widget.backupRow;
            widget.template = widget.templateToView;
        }
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Rec43000_ParametroContasReceber_Controller', Rec43000_ParametroContasReceber_Controller);
});